import { TaskColumn } from '../../attracttable/columns/Tasks';
import { FirstTaskDueDate, NextTaskDueDate, LastTaskDueDate } from '../../attracttable/columns/TaskDueDate';
import { Status } from '../../attracttable/columns/Status';
import { RowObject } from '../../attracttable/columns/RowObject'
let ColumnFactoryBase = pillar.vuecomponents.table.columns.ColumnFactoryBase;


class AssetColumnFactory extends ColumnFactoryBase{
    thenGetColumns() {
        return this.thenGetProject()
        .then((project) => {
            let taskTypes = project.extension_props.attract.task_types.attract_asset;
            let taskColumns = taskTypes.map((tType) => {
                return new TaskColumn(tType, 'asset-task');
            })

            return [new Status(), new RowObject()]
                .concat(taskColumns)
                .concat([new NextTaskDueDate(),]);
        })
    }
}

export { AssetColumnFactory }
