import { AttractRowBase } from '../../attracttable/rows/AttractRowBase'
import { TaskEventListener } from '../../attracttable/rows/TaskEventListener';

class AssetRow extends AttractRowBase {
    constructor(asset) {
        super(asset);
        this.tasks = [];
    }

    thenInit() {
        return attract.api.thenGetTasks(this.getId())
        .then((response) => {
            this.tasks = response._items;
            this.registerTaskEventListeners();
            this.isInitialized = true;
        });
    }

    registerTaskEventListeners() {
        new TaskEventListener(this).register();
    }

    getTasksOfType(taskType) {
        return this.tasks.filter((t) => {
            return t.properties.task_type === taskType;
        })
    }
}

export { AssetRow }
