let RowFilterBase = pillar.vuecomponents.table.filter.RowFilter;
const TEMPLATE =`
<div class="pillar-table-row-filter">
    <input 
        placeholder="Filter by name"
        v-model="nameQuery"
    />
    <pillar-dropdown>
        <i class="pi-filter"
            slot="button"
            title="Row filter"
        />

        <ul class="settings-menu"
            slot="menu"
        >   
            <li>
                Status:
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.final"
                /> Final
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.approved"
                /> Approved
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.cbb"
                /> Cbb
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.review"
                /> Review
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.in_progress"
                /> In Progress
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.todo"
                /> Todo
            </li>
            <li>
                <input type="checkbox"
                    v-model="showAssetStatus.on_hold"
                /> On Hold
            </li>
        </ul>
    </pillar-dropdown>
</div>
`;

let RowFilter = {
    extends: RowFilterBase,
    template: TEMPLATE,
    props: {
        rowObjects: Array
    },
    data() {
        return {
            showAssetStatus: {
                todo: true,
                in_progress: true,
                on_hold: true,
                approved: true,
                cbb: true,
                final: true,
                review: true,
            },
        }
    },
    computed: {
        nameQueryLoweCase() {
            return this.nameQuery.toLowerCase();
        },
        visibleRowObjects() {
            return this.rowObjects.filter((row) => {
                if (!this.hasShowStatus(row)) return false;
                return this.filterByName(row);
            });
        }
    },
    methods: {
        hasShowStatus(rowObject) {
            let status = rowObject.getProperties().status;
            return !(this.showAssetStatus[status] === false); // To handle invalid statuses
        },
    },
};

export { RowFilter }
