let PillarTable = pillar.vuecomponents.table.PillarTable;
import {TasksColumnFactory} from './columns/TasksColumnFactory'
import {TaskRowsSource} from './rows/TaskRowsSource'
import {RowFilter} from '../attracttable/filter/RowFilter'

const TEMPLATE =`
<div class="pillar-table-actions">
    <button class="action"
        v-if="canAddTask"
        @click="createNewTask"
    >
        <i class="pi-plus">New Task</i>
    </button>
</div>
`;

let TableActions = {
    template: TEMPLATE,
    computed: {
        canAddTask() {
            let projectId = ProjectUtils.projectId();
            return attract.auth.AttractAuth.canUserCreateTask(projectId);
        }
    },
    methods: {
        createNewTask() {
            task_create(undefined, 'generic');
        }
    },
}

Vue.component('attract-tasks-table', {
    extends: PillarTable,
    columnFactory: TasksColumnFactory,
    rowsSource: TaskRowsSource,
    components: {
        'pillar-table-actions': TableActions,
        'pillar-table-row-filter': RowFilter,
    }
});
