import { Status } from '../../attracttable/columns/Status'
import { RowObject } from '../../attracttable/columns/RowObject'
import { TaskDueDate } from '../../attracttable/columns/TaskDueDate'
import { TaskType } from './TaskType'
import { ShortCode } from './ShortCode'
import { ParentName } from './ParentName'

let ColumnFactoryBase = pillar.vuecomponents.table.columns.ColumnFactoryBase;


class TasksColumnFactory extends ColumnFactoryBase{
    thenGetColumns() {
        return this.thenGetProject()
        .then((project) => {
            return [
                new Status(),
                new ParentName(),
                new RowObject(),
                new ShortCode(),
                new TaskType(),
                new TaskDueDate(),
            ];
        })
    }
}

export { TasksColumnFactory }
